//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright ""

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  DimGray
#property indicator_color2  PaleVioletRed
#property indicator_color3  DeepSkyBlue
#property indicator_color4  LimeGreen
#property indicator_color5  Red
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_style5  STYLE_DOT

//
//
//
//
//

   extern int PeriodRSI   = 13;
   extern int PeriodStoch = 10;
   extern int PeriodSK    =  5;
   extern int PeriodSD    =  5;
         //    0 = SMA
         //    1 - EMA
         //    2 - SMMA
         //    3 - LWMA
   extern int    MAMode       =   0;
   extern int    MinMaxPeriod =  50;
   extern double LevelUp      =  80;
   extern double LevelDown    =  20;

//
//
//
//
//

double SK[];
double SD[];
double StoRSI[];
double RSI[];
double levelUp[];
double levelMi[];
double levelDn[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,levelUp);
      SetIndexBuffer(1,levelMi);
      SetIndexBuffer(2,levelDn);
      SetIndexBuffer(3,SK);
      SetIndexBuffer(4,SD);
      SetIndexBuffer(5,StoRSI);
      SetIndexBuffer(6,RSI);
   IndicatorShortName("DTOSC ("+PeriodRSI+","+PeriodStoch+","+PeriodSK+","+PeriodSD+")");
return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
             int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
             
   for(int i=limit; i>=0; i--)
   {
      RSI[i] = iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i);
      double LLV = RSI[ArrayMinimum(RSI,PeriodStoch,i)];
      double HHV = RSI[ArrayMaximum(RSI,PeriodStoch,i)];
      if ((HHV-LLV)!=0)
            StoRSI[i] = 100.0*((RSI[i] - LLV)/(HHV - LLV));
      else  StoRSI[i] = 0;
   }   
   for(i=limit; i>=0; i--) SK[i]=iMAOnArray(StoRSI,0,PeriodSK,0,MAMode,i);
   for(i=limit; i>=0; i--)
   {
      SD[i]=iMAOnArray(    SK,0,PeriodSD,0,MAMode,i);
      double skMin = SK[ArrayMinimum(SK,MinMaxPeriod,i)];
      double skMax = SK[ArrayMaximum(SK,MinMaxPeriod,i)];
      double range = skMax-skMin;
               levelUp[i] = skMin+range*LevelDown/100.0;
               levelMi[i] = skMin+range*0.5;
               levelDn[i] = skMin+range*LevelUp/100.0;
   }      
   return(0);
}